;;; Sierra Script 1.0 - (do not remove this comment)
(script# 84)
(include system.sh) (include sci2.sh) (include game.sh)
(use Main)
(use ThrowFlameDart)
(use ThrowDagger1)
(use ThrowRock)
(use AnimateDazzle)
(use TargActor)
(use LoadMany)
(use Sound)
(use Motion)
(use Game)
(use Inventory)
(use Actor)
(use System)

(public
	rm84 0
)

(local
	antwerpOnScreen
	local1 =  90
	local2 =  40
	local3 =  20
	local4
	local5
	local6 =  114
	local7 =  96
	local8 =  1
	local9 =  6
	local10
	fightWithSword
)
(instance rm84 of Room
	(properties
		picture 84
		style DISSOLVE
		north 78
		east 85
	)
	
	(method (init)
		(super init:)
		(gMouseHandler add: self)
		(StatusLine enable:)
		(cSound fade:)
		(self setLocales: FOREST)
		(if (or (== prevRoomNum 97) (== prevRoomNum 89))
			(Bset TROLL_DOOR_OPEN)
		)
		(if (Bset VISITED_BRIGAND_COURTYARD) (Bset 348))
		(StopEgo)
		(ego init:)
		(if (not (Btst TROLL_DOOR_OPEN))
			(ego illegalBits: -32704)
			(rock init: stopUpd:)
		)
		(if
		(= antwerpOnScreen (not (if (Btst ANTWERP_SPLIT) else (Btst ANTWERP_SKY))))
			(antwerp init: loop: 3 setScript: bounceAndLook)
			(LoadMany RES_VIEW 590 513 502 503 510 84)
			(LoadMany RES_SOUND
				(GetSongNumber 4)
				(GetSongNumber 5)
				(GetSongNumber 6)
				(GetSongNumber 9)
				54
			)
			(cSound stop:)
			(antSound number: (GetSongNumber 4) init:)
			(antHits init:)
			(cond 
				((= fightWithSword (ego has: iSword)) (Load RES_VIEW 501))
				((ego has: iDagger) (Load RES_VIEW 512))
			)
		)
		(switch prevRoomNum
			(89
				(ego posn: 25 90 setMotion: MoveTo 36 90)
			)
			(97
				(ego posn: 25 90 setMotion: MoveTo 36 90)
			)
			(78
				(ego posn: 160 30 setMotion: MoveTo 198 75)
			)
			(85
				(ego posn: 319 100 setMotion: MoveTo 295 100)
			)
		)
	)
	
	(method (doit)
		(cond 
			(
			(and (== (ego onControl: 1) 4096) (== (ego loop?) 3)) (curRoom newRoom: 78))
			((<= (ego x?) 25) (curRoom newRoom: 89))
		)
		(super doit:)
	)
	
	(method (dispose)
		(gMouseHandler delete: self)
		(Bset VISITED_ANTWERP)
		(if (!= newRoomNum 89)
			(Bclr SAID_HIDEN_GOSEKE)
			(if (not (if (Btst DEFEATED_FRED) else (Btst DEFEATED_FRED_89)))
				(Bclr TROLL_DOOR_OPEN)
				(Bclr TROLL_DOOR_UNLOCKED)
			)
		)
		(super dispose:)
	)
	
	(method (handleEvent event &tmp [str 30] spell projectile)
		(switch (event type?)
			(mouseDown
				(cond 
					((super handleEvent: event))
					((IsObjectOnControl ego event emRIGHT_BUTTON)
						(HighPrint (Format @str 84 0 @userName)
							;By golly, It's %s!
						)
					)
				)
			)
			(evSAID
				(cond 
					((super handleEvent: event))
					((Said 'look,search>')
						(cond 
							((Said '[<at,around][/place,area]')
								(cond 
									((Btst ANTWERP_SPLIT)
										(HighPrint 84 1)
										;Now that the big Antwerp has split, this corner of the forest seems strangely quiet.
										)
									((Btst ANTWERP_SKY)
										(HighPrint 84 2)
										;You look around and see rocks and grass, but no Antwerp.
										)
									(else
										(HighPrint 84 3)
										;You see rocks, grass and an Antwerp.
										)
								)
							)
							(
								(Said
									'[<at,around][/antwerp,monster,creature,beast,animal,bouncer]'
								)
								(cond 
									((Btst ANTWERP_SPLIT)
										(HighPrint 84 4)
										;The only Antwerp known in these parts has split... into parts.
										)
									((Btst ANTWERP_SKY)
										(HighPrint 84 5)
										;The Antwerp seems to have flown the coop.
										)
									(else
										(HighPrint 84 6)
										;Antwerps are on the endangered species list.  They are rarely seen.
										)
								)
							)
							((Said '[<at][/boulder,boulder]')
								(cond 
									((not (ego inRect: 0 72 66 102))
										(HighPrint 84 7)
										;The rocks were left here by some receding glacier.
										)
									((Btst TROLL_DOOR_OPEN)
										(HighPrint 84 8)
										;There is a narrow cave entrance among the rocks.
										)
									(else
										(HighPrint 84 9)
										;You find a keyhole concealed in a crack in the rock.
										)
								)
							)
							((or (Said '/cave,entrance') (Said '<in'))
								(if (Btst TROLL_DOOR_OPEN)
									(HighPrint 84 10)
									;There is a narrow cave entrance among the rocks.  Inside, you see a dark passage through the hillside.
								else
									(HighPrint 84 11)
									;You see nothing like that here.
								)
							)
							((Said '/door,keyhole,hasp')
								(if (ego inRect: 0 72 66 102)
									(HighPrint 84 9)
									;You find a keyhole concealed in a crack in the rock.
								else
									(HighPrint 84 12)
									;You do not find anything nearby.
								)
							)
							((or (Said '<up') (Said '/sky'))
								(HighPrint 84 13)
								;The sky is clear.
								)
							((or (Said '<down') (Said '/ground,grass'))
								(HighPrint 84 14)
								;The grass is luscious, just the thing for hungry herbivores.
								)
							((Said '/south,west')
								(HighPrint 84 15)
								;The way is impassable.  Sheer rock cliffs rise to serious heights.
								)
							((Said '/east,north')
								
								(HighPrint 84 16)
								;The forest extends to the east and north.
								)
						)
					)
					((Said 'cast>')
						(switch (= spell (SaidCast event))
							(DETMAGIC
								(if (CastSpell spell)
									(HighPrint 84 17)
									;You detect no magic here.
									)
							)
							(DAZZLE
								(if (CastSpell spell)
									(AnimateDazzle)
									(if antwerpOnScreen
										(HighPrint 84 18)
										;Antwerps aren't dazzled easily.
										)
								)
							)
							(FLAMEDART
								(if (CastSpell spell)
									(if (gCast contains: antwerp)
										(FaceObject ego antwerp)
										(SetUpEgo)
									)
									(if antwerpOnScreen
										(AnimateThrowingFlameDart antwerp)
										(antwerp setScript: antwerpAway)
									else
										(AnimateThrowingFlameDart 0)
									)
								)
							)
							(OPEN
								(cond 
									((not (ego inRect: 0 72 66 102))
										(HighPrint 84 19)
										;You aren't close enough to a lock.
										)
									((CastSpell spell)
										(if (Btst TROLL_DOOR_UNLOCKED)
											(HighPrint 84 20)
											;It's already unlocked.
										else
											(self setScript: sMagicRock)
										)
									)
								)
							)
							(else  (event claimed: FALSE))
						)
					)
					((Said 'throw/dagger,dagger')
						(= projectile (if (gCast contains: antwerp) antwerp else 0))
						(if (AnimateThrowingDagger projectile)
							(if (gCast contains: antwerp)
								(= daggersInRoom (+ daggersInRoom daggersInMonster))
								(= daggersInMonster 0)
								(FaceObject ego antwerp)
								(SetUpEgo)
							)
							(if antwerpOnScreen (antwerp setScript: antwerpAway))
						)
					)
					((Said 'throw/boulder')
						(= projectile (if (gCast contains: antwerp) antwerp else 0))
						(if (AnimateThrowingRock projectile)
							(if (gCast contains: antwerp)
								(FaceObject ego antwerp)
								(SetUpEgo)
							)
							(if antwerpOnScreen (antwerp setScript: antwerpAway))
						)
					)
					(
						(Said
							'fight,kill[/bouncer,antwerp,animal,beast,monster,creature]'
						)
						(cond 
							((Btst ANTWERP_SPLIT)
								(HighPrint 84 4)
								;The only Antwerp known in these parts has split... into parts.
								)
							((Btst ANTWERP_SKY)
								(HighPrint 84 5)
								;The Antwerp seems to have flown the coop.
								)
							((or fightWithSword (ego has: iDagger)) (antwerp setScript: fightAntwerp))
							(else
								(HighPrint 84 21)
								;You have no weapon with which to fight the Antwerp.
								(HighPrint 84 22)
								;However, you bravely attack the bouncing beast with your bare hands.
								(ego setScript: bareHandAttack)
							)
						)
					)
					(
						(Said
							'feed[/antwerp,creature,monster,bouncer,animal,beast]'
						)
						(cond 
							((Btst ANTWERP_SPLIT)
								(HighPrint 84 23)
								;The only Antwerp known to these parts, split ...into parts.
								)
							((Btst ANTWERP_SKY)
								(HighPrint 84 5)
								;The Antwerp seems to have flown the coop.
								)
							(else (HighPrint 84 24)
								;He's on a diet.
								)
						)
					)
					(
						(or
							(Said 'unlock,lockpick/door,boulder,hasp,keyhole')
							(Said 'use/key,lockpick')
							(Said 'open/hasp,keyhole')
							(Said 'put,fill<in/key/hasp')
						)
						(cond 
							((not (ego inRect: 0 72 66 102))
								(HighPrint 84 25)
								;You don't see any locks nearby.
								)
							((Btst TROLL_DOOR_UNLOCKED)
								(HighPrint 84 20)
								;It's already unlocked.
								)
							((and (ego has: iBrassKey) (Btst OBTAINED_BRUTUS_KEY))
								(HighPrint 84 26)
								;The lock in the rock clicks open.
								(Bset TROLL_DOOR_UNLOCKED))
							((not (CanPickLocks))
								(HighPrint 84 27)
								;You'd have a much easier time of this if you had the key.
								)
							((TrySkill PICK 85 lockPickBonus)
								(HighPrint 84 28)
								;Ah, got it!  The lock in the rock clicks open.
								(Bset TROLL_DOOR_UNLOCKED)
								)
							(else
								(HighPrint 84 29)
								;The lock is beyond your present skill.  It might help if you had the key.
								(if (not (ego has: iThiefKit))
									(HighPrint 84 30)
									;... Or at least a better set of tools.
									)
							)
						)
					)
					((Said 'shove,move,force,get,open/boulder,door')
						(if (not (Btst TROLL_DOOR_OPEN))
							(if (Btst TROLL_DOOR_UNLOCKED)
								(if (TrySkill STR 40 0)
									(rock setScript: sMoveRock)
								else
									(HighPrint 84 31)
									;You are not strong enough yet to open the rock door.
								)
							else
								(HighPrint 84 32)
								;Despite your mightiest efforts, the rock does not move.
							)
						else
							(HighPrint 84 33)
							;The rock door has already been opened.
						)
					)
					(
						(or
							(Said 'say,holler<hiden/goseke')
							(Said 'hiden/goseke')
						)
						(if
							(and
								(Btst SPIED_THIEVES)
								(ego inRect: 0 72 66 102)
								(Btst TROLL_DOOR_OPEN)
								(not (Btst SAID_HIDEN_GOSEKE))
								(not (Btst DEFEATED_FRED))
							)
							(Bset SAID_HIDEN_GOSEKE)
							(AddToScore POINTS_GIVECAVEPASSWORD 5)
							(HighPrint 84 34)
							;You hear the sound of someone...or something...moving deeper into the cave to let you pass.
						else
							(HighPrint 84 35)
							;Ok, you say Hiden Goseke.
						)
					)
					((Said 'enter/cave,entrance')
						(HighPrint 84 36)
						;Go ahead. If you dare.
						)
				)
			)
		)
	)
)

(instance antwerp of TargActor
	(properties
		y 96
		x 114
		yStep 4
		view 590
		loop 2
		cycleSpeed 1
		xStep 4
		moveSpeed 1
	)
	
	(method (doit)
		(if
			(and
				(== (self loop?) 0)
				(== (antSound loop?) 0)
				(== (self cel?) 0)
				(!= (self script?) fightAntwerp)
			)
			(antSound loop: 1 play:)
		)
		(super doit:)
	)
	
	(method (handleEvent event)
		(switch (event type?)
			(mouseDown
				(if (IsObjectOnControl antwerp event emRIGHT_BUTTON)
					(HighPrint 84 38)
					;By golly, it's an Antwerp!
				)
			)
			(evSAID
				(cond 
					((super handleEvent: event))
					(
						(Said
							'play/[antwerp,monster,creature,bouncer,animal,beast]'
						)
						(HighPrint 84 39)
						;The Antwerp plays rough.
					)
				)
			)
		)
	)
	
	(method (getHurt)
		(HighPrint 84 37)
		;That's funny.  It bounced right off.
	)
)

(instance bounceAndLook of Script
	(properties)
	
	(method (doit)
		(cond 
			(
				(and
					(< (- (antwerp x?) local1) (ego x?))
					(< (ego x?) (+ (antwerp x?) local1))
					(< (- (antwerp y?) local2) (ego y?))
					(< (ego y?) (+ (antwerp y?) local2))
				)
				(antwerp cycleSpeed: 0 moveSpeed: 0)
				(client setScript: antwerpFollow)
			)
			(
				(or
					(and
						(< (antwerp x?) (ego x?))
						(!= (antwerp loop?) 0)
					)
					(and
						(> (antwerp x?) (ego x?))
						(!= (antwerp loop?) 1)
					)
				)
				(self changeState: 0)
			)
		)
		(super doit:)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(antSound number: (GetSongNumber 4) play:)
				(if (< (antwerp x?) (ego x?))
					(antwerp
						loop: 0
						cycleSpeed: 1
						moveSpeed: 1
						setCycle: EndLoop self
					)
				else
					(antwerp
						loop: 1
						cycleSpeed: 1
						moveSpeed: 1
						setCycle: EndLoop self
					)
				)
			)
			(1 (self changeState: 0))
		)
	)
)

(instance antwerpFollow of Script
	(properties)
	
	(method (doit)
		(asm
			pushi    #x
			pushi    0
			lag      ego
			send     4
			push    
			pushi    #x
			pushi    0
			lofsa    antwerp
			send     4
			sub     
			sal      local4
			pushi    #y
			pushi    0
			lag      ego
			send     4
			push    
			pushi    #y
			pushi    0
			lofsa    antwerp
			send     4
			sub     
			sal      local5
			pushi    65491
			lal      local4
			lt?     
			bnt      code_0bf7
			pprev   
			ldi      45
			lt?     
			bnt      code_0bf7
			pushi    65528
			lal      local5
			lt?     
			bnt      code_0bf7
			pprev   
			ldi      8
			lt?     
			bnt      code_0bf7
			pushi    #cycleSpeed
			pushi    1
			pushi    1
			pushi    56
			pushi    1
			pushi    1
			lofsa    antwerp
			send     12
			pushi    #setScript
			pushi    1
			lofsa    antwerpPushes
			push    
			pToa     client
			send     6
code_0bf7:
			-al      local8
			bnt      code_0bff
			jmp      code_0ce6
code_0bff:
			lal      local1
			neg     
			push    
			lal      local4
			lt?     
			bnt      code_0c0d
			pprev   
			lal      local1
			lt?     
code_0c0d:
			not     
			bt       code_0c23
			lal      local2
			neg     
			push    
			lal      local5
			lt?     
			bnt      code_0c1f
			pprev   
			lal      local2
			lt?     
code_0c1f:
			not     
			bnt      code_0c2d
code_0c23:
			pushi    #changeState
			pushi    1
			pushi    7
			self     6
			jmp      code_0ce6
code_0c2d:
			lsl      local4
			lal      local2
			mul     
			push    
			lsl      local5
			lal      local3
			mul     
			sub     
			push    
			ldi      0
			lt?     
			bnt      code_0c5c
			lsl      local5
			lal      local3
			mul     
			push    
			lsl      local4
			lal      local2
			mul     
			add     
			push    
			ldi      0
			lt?     
			bnt      code_0c5c
			pushi    #changeState
			pushi    1
			pushi    1
			self     6
			jmp      code_0ce6
code_0c5c:
			lsl      local4
			lal      local2
			mul     
			push    
			lsl      local5
			lal      local3
			mul     
			sub     
			push    
			ldi      0
			gt?     
			bnt      code_0c80
			lsl      local4
			ldi      0
			lt?     
			bnt      code_0c80
			pushi    #changeState
			pushi    1
			pushi    2
			self     6
			jmp      code_0ce6
code_0c80:
			lsl      local5
			lal      local3
			mul     
			push    
			lsl      local4
			lal      local2
			mul     
			add     
			push    
			ldi      0
			lt?     
			bnt      code_0c9d
			pushi    #changeState
			pushi    1
			pushi    3
			self     6
			jmp      code_0ce6
code_0c9d:
			lsl      local4
			lal      local2
			mul     
			push    
			lsl      local5
			lal      local3
			mul     
			sub     
			push    
			ldi      0
			gt?     
			bnt      code_0cba
			pushi    #changeState
			pushi    1
			pushi    4
			self     6
			jmp      code_0ce6
code_0cba:
			lsl      local4
			lal      local2
			mul     
			push    
			lsl      local5
			lal      local3
			mul     
			sub     
			push    
			ldi      0
			lt?     
			bnt      code_0cdf
			lsl      local4
			ldi      0
			gt?     
			bnt      code_0cdf
			pushi    #changeState
			pushi    1
			pushi    5
			self     6
			jmp      code_0ce6
code_0cdf:
			pushi    #changeState
			pushi    1
			pushi    6
			self     6
code_0ce6:
			lal      local8
			not     
			bnt      code_0cf0
			lal      local9
			sal      local8
code_0cf0:
			pushi    #doit
			pushi    0
			super    Script,  4
			ret     
		)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0)
			(1
				(if
					(and
						(< (- local6 local1) (ego x?))
						(< (ego x?) (+ local6 local1))
						(< (- local7 local2) (ego y?))
						(< (ego y?) (+ local7 local2))
					)
					(cond 
						((<= (antwerp x?) local6)
							(antwerp
								setLoop: 1
								setCycle: Forward
								setMotion: MoveTo local6 (ego y?)
							)
						)
						((<= (/ (+ (antwerp x?) (ego x?)) 2) local6)
							(antwerp
								setLoop: 1
								setCycle: Forward
								setMotion: MoveTo local6 (ego y?)
							)
						)
						(else
							(antwerp
								setLoop: 1
								setCycle: Forward
								setMotion: MoveTo (+ (antwerp x?) (ego x?)) (ego y?)
							)
						)
					)
				else
					(antwerp
						setLoop: 1
						setCycle: Forward
						setMotion: MoveTo local6 local7
					)
				)
			)
			(2
				(antwerp
					setLoop: 1
					setCycle: Forward
					setMotion:
						MoveTo
						(+ (antwerp x?) (/ local5 2))
						(- (antwerp y?) (/ local5 2))
				)
			)
			(3
				(antwerp
					setLoop: 0
					setCycle: Forward
					setMotion:
						MoveTo
						(- (antwerp x?) (/ local5 2))
						(- (antwerp y?) (/ local5 2))
				)
			)
			(4
				(if
					(and
						(< (- local6 local1) (ego x?))
						(< (ego x?) (+ local6 local1))
						(< (- local7 local2) (ego y?))
						(< (ego y?) (+ local7 local2))
					)
					(cond 
						((>= (antwerp x?) local6)
							(antwerp
								setLoop: 0
								setCycle: Forward
								setMotion: MoveTo local6 (ego y?)
							)
						)
						((>= (/ (+ (antwerp x?) (ego x?)) 2) local6)
							(antwerp
								setLoop: 0
								setCycle: Forward
								setMotion: MoveTo local6 (ego y?)
							)
						)
						(else
							(antwerp
								setLoop: 0
								setCycle: Forward
								setMotion: MoveTo (+ (antwerp x?) (ego x?)) (ego y?)
							)
						)
					)
				else
					(antwerp
						setLoop: 0
						setCycle: Forward
						setMotion: MoveTo local6 local7
					)
				)
			)
			(5
				(antwerp
					setLoop: 0
					setCycle: Forward
					setMotion:
						MoveTo
						(- (antwerp x?) (/ local5 2))
						(+ (antwerp y?) (/ local5 2))
				)
			)
			(6
				(antwerp
					setLoop: 1
					setCycle: Forward
					setMotion:
						MoveTo
						(+ (antwerp x?) (/ local5 2))
						(+ (antwerp y?) (/ local5 2))
				)
			)
			(7
				(antwerp
					setLoop: 0
					setCycle: Forward
					setMotion: MoveTo local6 local7 self
				)
			)
			(8
				(client setScript: bounceAndLook)
			)
		)
	)
)

(instance antwerpPushes of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(HandsOff)
				(if (< (ego x?) (antwerp x?))
					(ego
						ignoreActors:
						setMotion: MoveTo (- (antwerp x?) 30) (antwerp y?) self
					)
				else
					(ego
						ignoreActors:
						setMotion: MoveTo (+ (antwerp x?) 30) (antwerp y?) self
					)
				)
			)
			(1
				(if (< (ego x?) (antwerp x?))
					(antwerp
						setLoop: 1
						cel: 0
						setCycle: Forward
						setMotion: MoveTo (+ (ego x?) 21) (antwerp y?) self
					)
					(ego
						view: 513
						setLoop: 2
						cycleSpeed: 1
						setCycle: EndLoop
						setMotion: MoveTo (- (ego x?) 10) (ego y?)
					)
				else
					(antwerp
						setLoop: 0
						cel: 0
						setCycle: Forward
						setMotion: MoveTo (- (ego x?) 21) (antwerp y?) self
					)
					(ego
						view: 513
						setLoop: 3
						cycleSpeed: 1
						setCycle: EndLoop
						setMotion: MoveTo (+ (ego x?) 10) (ego y?)
					)
				)
				(antHits play:)
			)
			(2
				(if (not (ReduceHP 10))
					(self changeState: 5)
				else
					(StopEgo)
					(if (not (Btst 253)) (ego illegalBits: -32704))
					(= local4 45)
					(if (< (ego x?) (antwerp x?))
						(if (> 226 (+ (antwerp x?) local4))
							(= local4 (- 226 (antwerp x?)))
						)
						(antwerp
							setLoop: 1
							cel: 0
							setCycle: Forward
							setMotion: MoveTo (+ (antwerp x?) local4) (antwerp y?) self
						)
						(ego loop: 0)
					else
						(if (> 82 (- (antwerp x?) local4))
							(= local4 (- (antwerp x?) 82))
						)
						(antwerp
							setLoop: 0
							cel: 0
							setCycle: Forward
							setMotion: MoveTo (- (antwerp x?) local4) (antwerp y?) self
						)
						(ego loop: 1)
					)
					(HandsOn)
				)
			)
			(3 (= seconds 3))
			(4
				(antwerp cycleSpeed: 0 moveSpeed: 0)
				(client setScript: antwerpFollow)
			)
			(5
				(= local4 25)
				(if (< (ego x?) (antwerp x?))
					(if (> 226 (+ (antwerp x?) local4))
						(= local4 (- 226 (antwerp x?)))
					)
					(antwerp
						setLoop: 1
						cel: 0
						setCycle: Forward
						setMotion: MoveTo (+ (antwerp x?) local4) (antwerp y?)
					)
					(ego loop: 2)
				else
					(if (> 82 (- (antwerp x?) local4))
						(= local4 (- (antwerp x?) 82))
					)
					(antwerp
						setLoop: 0
						cel: 0
						setCycle: Forward
						setMotion: MoveTo (- (antwerp x?) local4) (antwerp y?)
					)
					(ego loop: 1)
				)
				(ego
					view: 503
					setLoop: 0
					cel: 0
					cycleSpeed: 3
					setCycle: EndLoop self
				)
			)
			(6
				(EgoDead 84 40
					#icon 517 2 5
					#title {Your figure remains still and silent.}
					;The old ticker just couldn't keep going.  Maybe you shouldn't have missed the annual visit with your local Healer.
				)
			)
		)
	)
)

(instance fightAntwerp of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(HandsOff)
				(PrintTimedMessage 5 84 41)
				;Cockily, you loosen up to fight.
				(antwerp setMotion: MoveTo 114 96)
				(ego ignoreActors: setMotion: MoveTo 250 100 self)
			)
			(1
				(ego
					view: 502
					setLoop: (if fightWithSword 0 else 2)
					cel: 0
					cycleSpeed: 2
					setCycle: EndLoop self
				)
			)
			(2
				(if fightWithSword
					(ego view: 501 setLoop: 2)
				else
					(ego view: 512 setLoop: 5)
				)
				(ego cel: 0 setCycle: EndLoop self)
			)
			(3
				(ego
					cel: 0
					setLoop: (if fightWithSword 6 else 1)
					setCycle: EndLoop self
				)
			)
			(4
				(ego
					cel: 0
					setLoop: (if fightWithSword 3 else 0)
					setCycle: EndLoop self
				)
			)
			(5
				(ego
					cel: 0
					setLoop: (if fightWithSword 7 else 0)
					setCycle: EndLoop self
				)
			)
			(6
				(if local10
					(-- local10)
					(self changeState: 2)
				else
					(= local10 4)
					(= cycles 4)
				)
			)
			(7
				(ego
					cel: 0
					setLoop: (if fightWithSword 4 else 3)
					setCycle: EndLoop self
				)
			)
			(8
				(if local10
					(-- local10)
					(self changeState: 7)
				else
					(ego
						view: 502
						setLoop: (if fightWithSword 0 else 3)
						cel: 5
						setCycle: BegLoop self
					)
				)
			)
			(9
				(PrintTimedMessage 4 84 42)
				;Confident and loose, you approach the Antwerp.
				(StopEgo)
				(ego
					setLoop: 1
					moveSpeed: 1
					cycleSpeed: 1
					ignoreActors:
					setMotion: MoveTo 158 96 self
				)
			)
			(10
				(ego
					view: 502
					setLoop: (if fightWithSword 0 else 2)
					cel: 0
					moveSpeed: 0
					cycleSpeed: 0
					setCycle: EndLoop self
				)
			)
			(11
				(antwerp
					setLoop: 0
					setCycle: CycleTo 2 1
					setStep: 1 5
					setMotion: MoveTo 114 0
				)
				(antSound number: (GetSongNumber 4) play:)
				(= cycles 13)
			)
			(12
				(antSound stop:)
				(if fightWithSword
					(ego view: 501 setLoop: 3)
				else
					(ego view: 512 setLoop: 5)
				)
				(ego cel: 0 setCycle: EndLoop self)
			)
			(13
				(ego loop: (if fightWithSword 1 else 8) cel: 0)
				(antwerp setCycle: EndLoop setMotion: MoveTo 114 96 self)
			)
			(14
				(antwerp setCycle: Forward)
				(= cycles 10)
			)
			(15
				(antwerp
					yStep: 7
					setCycle: CycleTo 2 1
					ignoreActors: 1
					ignoreHorizon:
					illegalBits: 0
					setMotion: MoveTo 114 0
				)
				(antSound number: (GetSongNumber 5) play:)
				(= cycles 10)
			)
			(16
				(antSound stop:)
				(if fightWithSword
					(ego view: 501 setLoop: 3)
				else
					(ego view: 512 setLoop: 5)
				)
				(ego cel: 0 setCycle: EndLoop self)
			)
			(17 (= cycles 16))
			(18
				(antwerp setMotion: MoveTo 114 96 self)
				(ego loop: (if fightWithSword 1 else 8) cel: 0)
			)
			;CI: NOTE: This case already exists, and will probably never be executed
			(18
				(antSound number: (GetSongNumber 9) play:)
				(antwerp setCycle: CycleTo 2 1 setMotion: MoveTo 114 92 self)
			)
			(19
				(antSound stop:)
				(antwerp setCycle: BegLoop self)
			)
			(20
				(antSound number: (GetSongNumber 6) play:)
				(antwerp yStep: 10 setMotion: MoveTo 114 -10)
				(= cycles 10)
			)
			(21
				(antSound stop:)
				(if fightWithSword
					(ego view: 501 setLoop: 5 cel: 0)
				else
					(ego view: 512 setLoop: 5)
				)
				(ego cel: 0 cycleSpeed: 1 setCycle: EndLoop self)
			)
			(22
				(ego
					view: 502
					setLoop: (if fightWithSword 0 else 3)
					cel: (if fightWithSword 5 else 2)
					setCycle: BegLoop self
				)
			)
			(23
				(StopEgo)
				(if (not (Btst TROLL_DOOR_OPEN)) (ego illegalBits: -32704))
				(Bset ANTWERP_SKY)
				(HandsOn)
				(PrintTimedMessage 3 84 43)
				;"Holy Mackerel!"
			)
		)
	)
)

(instance antSound of Sound
	(properties
		priority 5
	)
)

(instance antHits of Sound
	(properties
		number 54
		priority 6
	)
)

(instance rock of Actor
	(properties
		y 89
		x 18
		yStep 1
		view 84
		xStep 1
	)
)

(instance sMoveRock of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(HandsOff)
				(ego
					view: 510
					setLoop: 1
					cel: 0
					cycleSpeed: 2
					setCycle: CycleTo 2 1 self
				)
			)
			(1
				(rock
					setCycle: 0
					startUpd:
					illegalBits: 0
					xStep: 3
					setMotion: MoveTo -18 89 self
				)
				(ego setCycle: BegLoop)
			)
			(2
				(ChangeEgoWalk MOVE_WALK 0)
				(ego illegalBits: -32768)
				(HandsOn)
				(AddToScore POINTS_FINDSECRETENTRANCE 10)
				(Bset TROLL_DOOR_OPEN)
				(rock dispose:)
			)
		)
	)
)

(instance sMagicRock of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(HandsOff)
				(ego
					view: 521
					illegalBits: 0
					setLoop: 0
					cycleSpeed: 1
					setCycle: EndLoop self
				)
			)
			(1
				(Bset 252)
				(ChangeEgoWalk MOVE_WALK 0)
				(if (< [egoStats OPEN] 50)
					(HighPrint 84 44)
					;Your spell has unlocked the lock on the rock, but it is not yet powerful enough to open the rock door.
					(HandsOn)
					(StopEgo)
					(ego illegalBits: -32704)
					(client setScript: 0)
				else
					(rock
						setCycle: 0
						startUpd:
						illegalBits: 0
						setMotion: MoveTo -18 89 self
					)
				)
			)
			(2
				(AddToScore POINTS_FINDSECRETENTRANCE 10)
				(Bset TROLL_DOOR_OPEN)
				(rock dispose:)
				(StopEgo)
				(HandsOn)
			)
		)
	)
)

(instance bareHandAttack of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(ego setMotion: MoveTo (antwerp x?) (antwerp y?) self)
			)
			(1 (client setScript: 0))
		)
	)
)

(instance antwerpAway of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(= antwerpOnScreen FALSE)
				(Bset ANTWERP_SKY)
				(antwerp setCycle: EndLoop self)
			)
			(1
				(antwerp
					setLoop: 2
					cel: 0
					ignoreHorizon:
					illegalBits: 0
					setPri: (antwerp priority?)
					setStep: 4 18
					setCycle: BegLoop
					setMotion: MoveTo 200 -10 self
				)
			)
			(2
				(HighPrint 84 45)
				;You seem to have scared the Antwerp with your behavior.
				)
		)
	)
)
