;;; Sierra Script 1.0 - (do not remove this comment)
(script# 15)
(include system.sh) (include sci2.sh) (include game.sh)
(use Main)
(use ThrowDagger1)
(use ThrowRock)
(use Interface)
(use TargActor)
(use LoadMany)
(use Sound)
(use Save)
(use Motion)
(use Game)
(use Inventory)
(use User)
(use Actor)
(use System)

(public
	rm15 0
	KoboldFight 1
	chest 2
	kobKey 3
	kobDazzle 4
	chestBlows 5
	AwakenKobold 6
	KoboldHurtEgo 7
	egoFighting 8
)

(local
	[local0 5] = [79 113 172 226 306]
	[local5 5] = [204 189 193 191 203]
	newView
	local11
	theCycles
	local13
	local14
	local15
	local16
	local17
	newSound
	[local19 11] = [17 44 17 251 101 183 283 316 102 244 169]
	[local30 11] = [47 155 134 186 47 145 124 212 161 51 55]
	[local41 5] = [-24 24 -17 17 -5]
	[local46 5] = [6 6 10 10 13]
)
(procedure (KoboldFight param1)
	(if (and param1 (not (Btst 283))) (HandsOn))
	(if fightingKobold
		(User canControl: FALSE)
		(if (ego has: iSword)
			(ego view: 501 setLoop: egoKoboldBattleLoop)
		else
			(ego view: 512 setLoop: (* egoKoboldBattleLoop 5))
		)
		(ego setCel: 0 illegalBits: 0 cycleSpeed: 0)
	else
		(StopEgo)
		(ego illegalBits: global282)
	)
)

(procedure (AwakenKobold)
	(return
		(if
			(and
				(not (Btst KOBOLD_AWAKE))
				(not (Btst DEFEATED_KOBOLD))
				(!= (kobold script?) kobWakeUp)
			)
			(kobold setScript: kobWakeUp)
			(return 1)
		else
			(return 0)
		)
	)
)

(procedure (KoboldHurtEgo param1)
	(if (not (ReduceHP param1)) (ego setScript: egoDies))
)

(procedure (SendKoboldSaidEvent param1 param2)
	(param1 type: 128 claimed: 0)
	(Parse param2 param1)
	(User said: param1)
)

(procedure (localproc_003c param1)
	(Print
		&rest
		#at
		-1
		150
		#width
		0
		#mode
		1
		#dispose
		#time
		param1
	)
)

(procedure (localproc_0058 param1)
	(Print
		&rest
		#at
		150
		2
		#width
		0
		#mode
		1
		#window
		kobWin
		#dispose
		#time
		param1
	)
)

(procedure (localproc_0079 param1)
	(Bset KOBOLD_CHEST_SEARCHED)
	(AddToScore POINTS_TAKEKOBOLDMONEY 5)
	(PrintWarning 15 0)
	(if param1 (param1 dispose:))
	(= global282 (& global282 $dfff))
	(ego illegalBits: global282 get: iGold 10 get: iSilver 60)
)

(procedure (localproc_0138 &tmp temp0 temp1)
	(if
		(!=
			(= temp1
				(cond 
					(
						(<
							(= temp0
								(GetAngle (kobold x?) (kobold y?) (ego x?) (ego y?))
							)
							120
						)
						1
					)
					((< temp0 150) 3)
					((> temp0 240) 0)
					((> temp0 210) 2)
					(else 4)
				)
			)
			(kobold loop?)
		)
		(kobold setLoop: temp1)
	)
)

(procedure (localproc_01b5 param1 param2 param3)
	(if (CastSpell param1)
		(Bset FIGHTING_KOBOLD)
		(AwakenKobold)
		(ego setScript: (ScriptID param2 param3))
	)
)

(procedure (SaidKoboldRoom param1 param2 param3)
	(cond 
		((Btst KOBOLD_AWAKE) (PrintWarning 15 1))
		((CastSpell param1) (ego setScript: (ScriptID param2 param3)))
	)
)

(class KScript of Script
	(properties
		client 0
		state $ffff
		start 0
		timer 0
		cycles 0
		seconds 0
		lastSeconds 0
		register 0
		script 0
		caller 0
		next 0
	)
	
	(method (cue)
		(if client (super cue:))
	)
)

(class ballScript of KScript
	(properties
		client 0
		state $ffff
		start 0
		timer 0
		cycles 0
		seconds 0
		lastSeconds 0
		register 0
		script 0
		caller 0
		next 0
	)
	
	(method (doit)
		(cond 
			((Btst DEFEATED_KOBOLD) (client dispose:))
			(
			(and (< state 2) (not (client inRect: 10 30 310 200))) (= register 0) (self changeState: 2))
			(else (super doit:))
		)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(ballSound play:)
				(if
					(>=
						(-
							(- 100 (/ [egoStats AGIL] 2))
							(/ (ego distanceTo: kobold) 5)
						)
						(RollDice)
					)
					(client setMotion: MoveTo (ego x?) (ego y?) self)
				else
					(client
						setMotion:
							MoveTo
							[local19 register]
							[local30 (= register (Random 0 2))]
							self
					)
				)
			)
			(1
				(cond 
					((< (ego distanceTo: client) 20) (= register 1) (self cue:))
					(
					(>= (= register (+ register (Random 1 4))) 11) (= register 0) (self cue:))
					(else
						(client
							setMotion: MoveTo [local19 register] [local30 (= state 0)] self
						)
					)
				)
			)
			(2
				(ballHits play:)
				(client
					setLoop: (if register 7 else 6)
					cel: 0
					setMotion: 0
					setCycle: EndLoop self
				)
				(if register
					(KoboldHurtEgo (if (ego has: 9) 15 else 20))
				)
			)
			(3 (client dispose:))
		)
	)
)

(instance rm15 of Room
	(properties
		picture 15
		style DISSOLVE
		west 14
	)
	
	(method (init)
		(= fightingKobold (= global289 0))
		(if [egoStats MAGIC]
			(LoadMany RES_SCRIPT 110 113 114 115)
			(Load RES_SOUND (GetSongNumber 33))
			(LoadMany RES_VIEW 520 521 522 532)
		)
		(if (not (Btst DEFEATED_KOBOLD))
			(Load RES_SCRIPT 111)
			(Load RES_SCRIPT 117)
			(Load RES_SOUND (GetSongNumber 45))
			(Load RES_SOUND (GetSongNumber 34))
			(LoadMany RES_VIEW 513 175 176 178 502)
			(if (ego has: iSword)
				(Load RES_VIEW 501)
			else
				(Load RES_VIEW 512)
				(Load RES_VIEW 524)
			)
		)
		(if (not (Btst KOBOLD_CHEST_UNLOCKED))
			(Load RES_SCRIPT 116)
			(Load RES_SOUND (GetSongNumber 36))
			(Load RES_SOUND (GetSongNumber 62))
		)
		(Load RES_VIEW 510)
		(AddToScore POINTS_ENTERKOBOLDCAVE 2)
		(StatusLine enable:)
		(super init:)
		(gKeyHandler add: self)
		(gMouseHandler add: self)
		(ChangeEgoWalk MOVE_WALK FALSE)
		(StopEgo)
		(ego posn: 1 63 init:)
		(drip init: setScript: dripper)
		(dripper cycles: (Random 5 25))
		(if (not (Btst OBTAINED_TOADSTOOLS)) (toadstools init: setPri: 9))
		(if (not (Btst KOBOLD_CHEST_UNLOCKED))
			(chest init: stopUpd:)
			(= global282 (| global282 $2000))
		)
		(if (not (Btst OBTAINED_KOBOLD_KEY))
			(if egoKoboldBattleLoop (kobKey posn: 52 84))
			(kobKey
				ignoreActors:
				setPri: (if egoKoboldBattleLoop 5 else 1)
				init:
				stopUpd:
			)
			(if (not (Btst DEFEATED_KOBOLD)) (kobKey hide:))
		)
		(if (not (Btst DEFEATED_KOBOLD))
			(= global282 (| global282 $4000))
			(kobold init:)
			(= gKobold kobold)
		)
		(ego illegalBits: global282)
		(self setScript: kobEnter)
	)
	
	(method (dispose)
		(Bset VISITED_KOBOLD_CAVE)
		(Bclr KOBOLD_CHEST_KNOWN)
		(super dispose:)
	)
	
	(method (handleEvent event &tmp eventType temp1 spell)
		(cls)
		(= eventType (event type?))
		(cond 
			((super handleEvent: event))
			((== eventType evMOUSEBUTTON)
				(cond 
					(
						(and
							(gCast contains: kobKey)
							(IsObjectOnControl kobKey event emRIGHT_BUTTON)
						)
						(SendKoboldSaidEvent event {look key})
					)
					(
						(and
							(gCast contains: treasure)
							(IsObjectOnControl treasure event emRIGHT_BUTTON)
						)
						(SendKoboldSaidEvent event {look coins})
					)
					(
						(and
							(gCast contains: chest)
							(IsObjectOnControl chest event emRIGHT_BUTTON)
						)
						(SendKoboldSaidEvent event {look chest})
					)
					(
						(and
							(gCast contains: toadstools)
							(IsObjectOnControl toadstools event emRIGHT_BUTTON)
						)
						(SendKoboldSaidEvent event {look mushroom})
					)
					(
						(and
							(not (Btst 150))
							(IsObjectOnControl kobold event emRIGHT_BUTTON)
						)
						(SendKoboldSaidEvent event {look kobold})
					)
				)
			)
			((!= eventType evSAID))
			(
			(and (not (Btst DEFEATED_KOBOLD)) (Said 'chat,ask,awaken')) (PrintWarning 15 2))
			((Said 'nap,rest') (PrintWarning 15 3))
			((Said 'search')
				(if (Btst KOBOLD_AWAKE)
					(PrintWarning 15 4)
				else
					(ego setScript: (ScriptID 112 0))
				)
			)
			(
			(Said 'get,grab,get/key[<kobold,brass,big,magic,glowing]')
				(cond 
					((gCast contains: kobKey)
						(= temp1 0)
						(cond 
							((> (ego distanceTo: kobKey) 40) (PrintWarning 15 5))
							((Btst 150) (PrintWarning 15 6) (= temp1 1))
							((Btst 153) (PrintWarning 15 7))
							((TrySkill STEALTH 35 0) (PrintWarning 15 8) (= temp1 1))
							(else (PrintWarning 15 9) (AwakenKobold))
						)
						(if temp1
							(ego get: iBrassKey)
							(Bset OBTAINED_KOBOLD_KEY)
							(AddToScore POINTS_TAKEKOBOLDKEY 7)
							(kobKey dispose:)
						)
					)
					((ego has: iBrassKey) (PrintWarning 15 10))
					((ego pickUp: iBrassKey 1) (PrintWarning 15 11))
					(else (PrintWarning 15 12))
				)
			)
			(
				(and
					(Btst KOBOLD_CHEST_KNOWN)
					(Said 'get,grab,get,move/chest,box,trunk')
				)
				(PrintWarning 15 13)
			)
			((Said 'get/loot,alm,gold,silver')
				(cond 
					(
						(and
							(< (ego distanceTo: chest) 25)
							(gCast contains: treasure)
						)
						(localproc_0079 treasure)
					)
					((Btst KOBOLD_CHEST_SEARCHED) (PrintWarning 15 14))
					((not (< (ego distanceTo: chest) 25)) (PrintWarning 15 15))
					((not (Btst KOBOLD_CHEST_UNLOCKED)) (PrintWarning 15 16))
					(else (localproc_0079 0))
				)
			)
			(
				(or
					(Said 'use,turn,open,unlock/key,chest,box,trunk[/key]')
					(Said 'put,fill<in/key/hasp')
				)
				(if (and (Btst KOBOLD_CHEST_KNOWN) (gCast contains: chest))
					(PrintWarning 15 17)
				else
					(PrintWarning 15 18)
				)
			)
			(
				(or
					(Said 'lockpick/hasp,keyhole,chest,box,trunk')
					(Said 'use,fill/lockpick,(implement,kit<thief)')
				)
				(cond 
					(
					(or (not (Btst KOBOLD_CHEST_KNOWN)) (not (gCast contains: chest))) (PrintWarning 15 18))
					((Btst KOBOLD_CHEST_UNLOCKED) (PrintWarning 15 19))
					((not (< (ego distanceTo: chest) 25)) (PrintNotCloseEnough))
					((not [egoStats PICK]) (PrintWarning 15 20))
					(else (ego setScript: (ScriptID 116 0) 0 0))
				)
			)
			(
			(Said 'force,break,pry/chest,box,trunk,hasp,lid')
				(cond 
					(
					(or (not (Btst KOBOLD_CHEST_KNOWN)) (not (gCast contains: chest))) (PrintWarning 15 21))
					((Btst KOBOLD_CHEST_UNLOCKED) (PrintWarning 15 19))
					((not (< (ego distanceTo: chest) 25)) (PrintNotCloseEnough))
					(else (ego setScript: (ScriptID 116 0) 0 1))
				)
			)
			(
				(and
					(gCast contains: toadstools)
					(Said 'get/toadstool,mushroom,food')
				)
				(if fightingKobold
					(PrintWarning 15 22)
				else
					(PrintWarning 15 23)
					(Bset OBTAINED_TOADSTOOLS)
					(Bset HAVE_KOBOLD_MUSHROOMS)
					(ego get: iMushroom 6)
					(toadstools dispose:)
				)
			)
			((Said 'get/fungus') (PrintWarning 15 24))
			((Said 'feel/chest,box,trunk') (SendKoboldSaidEvent event {look chest}))
			((Said 'look>')
				(cond 
					((Said '/west,open,entrance') (PrintWarning 15 25))
					(
						(or
							(Said
								'/stalactite,stalagmite,boulder,ceiling,roof,floor,ground,formation'
							)
							(Said '<up,down')
						)
						(PrintWarning 15 26)
					)
					(
					(Said '[<at,around][/!*,cave,room,area,wall,fungus]')
						(PrintWarning 15 27)
						(if (not (Btst DEFEATED_KOBOLD)) (PrintWarning 15 28))
					)
					((and (gCast contains: kobKey) (Said '/key')) (PrintWarning 15 29))
					((Said '/table,mushroom,toadstool,food')
						(if (gCast contains: toadstools)
							(HighPrint 15 30)
						else
							(PrintWarning 15 31)
						)
					)
					((Said '/kobold,creature,man,wizard')
						(if (not (Btst DEFEATED_KOBOLD))
							(PrintWarning 15 32)
							(if (not (Btst OBTAINED_KOBOLD_KEY)) (PrintWarning 15 33))
						else
							(PrintWarning 15 34)
						)
					)
					(
						(or
							(Said '<in/chest,box,trunk')
							(Said '/loot,alm,gold,silver')
						)
						(cond 
							((gCast contains: treasure) (PrintWarning 15 35))
							((not (gCast contains: chest)) (PrintWarning 15 36))
							((not (Btst KOBOLD_CHEST_KNOWN)) (PrintWarning 15 37))
							((Btst KOBOLD_CHEST_SEARCHED) (PrintWarning 15 38))
							((Btst KOBOLD_CHEST_UNLOCKED) (PrintWarning 15 39))
							(else (PrintWarning 15 40))
						)
					)
					((Said '/chest,box,trunk')
						(cond 
							((not (gCast contains: chest)) (PrintWarning 15 41))
							((Btst KOBOLD_CHEST_KNOWN) (PrintWarning 15 42))
							(else (PrintWarning 15 43))
						)
					)
				)
			)
			((Said 'run,escape')
				(PrintWarning 15 44)
				(if (not (Btst DEFEATED_KOBOLD)) (PrintWarning 15 45))
				(if fightingKobold (self setScript: (ScriptID 117 1)))
			)
			(
				(Said
					'fight,attack,kill,beat[/kobold,creature,man,wizard]'
				)
				(cond 
					(fightingKobold (PrintWarning 15 46))
					((Btst DEFEATED_KOBOLD) (PrintWarning 15 47))
					((not (if (ego has: iSword) else (ego has: iDagger))) (PrintWarning 15 48))
					(else (self setScript: (ScriptID 117 0)))
				)
			)
			((Said 'throw>')
				(cond 
					(fightingKobold (event claimed: 1) (PrintWarning 15 49))
					((Btst DEFEATED_KOBOLD))
					((Said '/dagger') (AnimateThrowingDagger kobold))
					((Said '/boulder') (AnimateThrowingRock kobold))
				)
			)
			((Said 'cast>')
				(if
					(and
						(= spell (SaidCast event))
						fightingKobold
						(ego has: iShield)
					)
					(PrintWarning 15 50)
					(event claimed: TRUE)
					(= spell -1)
				)
				(switch spell
					(-1)
					(0 (event claimed: FALSE))
					(DAZZLE
						(if (not (Btst DEFEATED_KOBOLD))
							(localproc_01b5 20 113 0)
						else
							(event claimed: FALSE)
						)
					)
					(FLAMEDART
						(if (not (Btst DEFEATED_KOBOLD))
							(localproc_01b5 23 110 0)
						else
							(event claimed: FALSE)
						)
					)
					(CALM (localproc_01b5 22 114 0))
					(ZAP (event claimed: FALSE))
					(fightingKobold
						(PrintWarning 15 1)
					)
					(DETMAGIC (SaidKoboldRoom 18 113 1))
					(OPEN
						(if
						(and (not (Btst KOBOLD_CHEST_UNLOCKED)) (gCast contains: chest))
							(SaidKoboldRoom 17 115 0)
						else
							(PrintWarning 15 51)
						)
					)
					(TRIGGER
						(if
						(and (not (Btst KOBOLD_CHEST_UNLOCKED)) (gCast contains: chest))
							(SaidKoboldRoom 19 115 1)
						else
							(PrintWarning 15 52)
						)
					)
					(FETCH
						(if
						(and (not (Btst DEFEATED_KOBOLD)) (gCast contains: kobKey))
							(SaidKoboldRoom 24 114 1)
						else
							(PrintWarning 15 53)
						)
					)
					(else  (event claimed: FALSE))
				)
			)
		)
	)
)

(instance kobKey of Actor
	(properties
		y 85
		x 229
		view 178
		loop 6
		cel 12
		illegalBits $0000
	)
)

(instance chest of Prop
	(properties
		y 173
		x 132
		view 15
		loop 1
	)
	
	(method (doit)
		(if
		(and (< (ego distanceTo: chest) 25) (not (Btst KOBOLD_CHEST_KNOWN)))
			(PrintWarning 15 54)
			(Bset KOBOLD_CHEST_KNOWN)
		)
		(super doit:)
	)
)

(instance chestBlows of KScript
	(properties)
	
	(method (dispose)
		(if (>= state 1) (newSound dispose:))
		(= local17 0)
		(super dispose:)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(client
					setLoop: 2
					cel: 0
					cycleSpeed: 0
					setCycle: CycleTo 4 1 self
				)
			)
			(1
				(Bset KOBOLD_CHEST_UNLOCKED)
				((= newSound (Sound new:))
					number: (GetSongNumber 62)
					priority: 15
					init:
					play:
				)
				(client setCycle: EndLoop)
				(AwakenKobold)
				(if (< (ego distanceTo: chest) 25)
					(= local17 1)
					(KoboldHurtEgo 20)
				)
				(= cycles 10)
			)
			(2
				(= cycles 1)
				(if (< (ego distanceTo: chest) 25)
					(PrintWarning 15 55)
					(= cycles 5)
				)
			)
			(3
				(treasure init:)
				(KoboldFight 1)
				(FaceObject ego treasure)
				(client dispose:)
			)
		)
	)
)

(instance treasure of View
	(properties
		y 173
		x 132
		view 15
		loop 2
		cel 8
	)
)

(instance toadstools of View
	(properties
		y 117
		x 213
		view 15
		loop 3
	)
)

(instance drip of Prop
	(properties
		y 204
		x 79
		view 15
	)
)

(instance dripEndLoop of EndLoop
	(properties)
)

(instance dripper of KScript
	(properties)
	
	(method (changeState newState &tmp temp0)
		(switch (= state newState)
			(1
				(= temp0 (Random 0 4))
				(drip
					posn: [local0 temp0] [local5 temp0]
					setCycle: dripEndLoop
				)
				(= state 0)
				(= cycles (Random 20 40))
			)
		)
	)
)

(instance kobWin of SysWindow
	(properties
		color 6
	)
)

(instance ballSound of Sound
	(properties
		number 34
		priority 2
	)
)

(instance ballHits of Sound
	(properties
		number 45
		priority 3
	)
)

(instance kobold of TargActor
	(properties
		y 85
		x 229
		view 175
		loop 6
		cycleSpeed 3
		illegalBits $0000
		targDeltaY -15
	)
	
	(method (init)
		(Bclr 280)
		(Bclr 281)
		(ballSound number: (GetSongNumber 34) init:)
		(ballHits number: (GetSongNumber 45) init:)
		(if (ego knows: FLAMEDART)
			(= global346 (+ 5 (/ [egoStats FLAMEDART] 3)))
		)
		(= egoKoboldBattleLoop 0)
		(super ignoreActors: posn: 229 85 setPri: 6 init:)
		(if (< colourCount 8) (kobWin color: 0 back: 15))
		(if
			(or
				(not (Btst VISITED_KOBOLD_CAVE))
				(and
					(not isNightTime)
					(!= currentDay dayKoboldAwakened)
				)
			)
			(self setScript: kobAsleep)
		else
			(self setScript: kobAwake)
		)
		(= monsterInRoom KOBOLD)
		(= gMonsterHealth koboldHP)
	)
	
	(method (dispose)
		(Bclr KOBOLD_AWAKE)
		(ballHits dispose:)
		(ballSound dispose:)
		(if newView (newView dispose:))
		(super dispose:)
	)
	
	(method (getHurt param1)
		(= koboldHP (- koboldHP param1))
		(self setScript: kobHurt)
	)
)

(instance kobDazzle of KScript
	(properties)
	
	(method (dispose)
		(= local11 (* register 5))
		(super dispose:)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(SkillUsed DAZZLE 5)
				(= register (/ (+ 5 [egoStats DAZZLE]) 10))
				(if (> register 6) (= register 6))
				(client view: 179 setCel: 0)
				(= cycles 10)
			)
			(1
				(kobold setCel: -1 cycleSpeed: 2 setCycle: CycleTo 2 1)
				(= cycles 10)
			)
			(2
				(kobold setCel: 3)
				(= cycles 4)
			)
			(3
				(kobold setCel: 4)
				(= cycles 4)
			)
			(4
				(if (> (-- register) 0)
					(self changeState: 2)
				else
					(= cycles 5)
				)
			)
			(5
				(kobold setCel: 5)
				(= cycles 20)
			)
			(6 (client setScript: kobAwake))
		)
	)
)

(instance kobWakeUp of KScript
	(properties)
	
	(method (dispose)
		(if newView
			(newView dispose:)
			(= newView 0)
			(client setCycle: 0)
		)
		(if egoKoboldBattleLoop
			(client posn: 52 84)
		else
			(client posn: 229 85)
		)
		(cSound stop:)
		(super dispose:)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(Bset KOBOLD_AWAKE)
				(client setCycle: EndLoop)
				(= cycles 12)
			)
			(1
				(client setLoop: 7 setCycle: Forward)
				(localproc_0058 5 15 56)
				(= seconds 3)
			)
			(2 (client setScript: kobAwake))
		)
	)
)

(instance kobAwake of KScript
	(properties)
	
	(method (doit)
		(localproc_0138)
		(if (and (Btst 280) (== state 0))
			(Bclr 280)
			(self changeState: 3)
		)
		(super doit:)
	)
	
	(method (changeState newState &tmp clientLoop)
		(switch (= state newState)
			(0
				(Bset KOBOLD_AWAKE)
				(= dayKoboldAwakened currentDay)
				(client view: 175 cel: 0 setCycle: 0)
				(localproc_0138)
				(if egoKoboldBattleLoop
					(client posn: 52 84)
				else
					(client posn: 229 85)
				)
				(cond 
					(local11
						(client view: 179 setCel: 1)
						(= cycles (Random 25 50))
						(= local11 0)
					)
					((and (Btst 166) (not (Btst 281))) (= cycles (Random 5 15)))
					(gCycles (= cycles gCycles) (= gCycles 0))
					(theCycles (= cycles theCycles))
					(else (= cycles (Random 25 50)))
				)
			)
			(1
				(client view: 175)
				(cond 
					((and (Btst 166) (not (Btst 281))) (client setScript: castRev))
					(theCycles (= theCycles 0) (client setScript: castTele))
					(else (client view: 177 cycleSpeed: 0 setCycle: EndLoop self))
				)
			)
			(2
				(= clientLoop (client loop?))
				((Actor new:)
					ignoreActors:
					illegalBits: 0
					view: 177
					setLoop: 5
					setStep: 24 16
					posn:
						(+ (client x?) [local41 clientLoop])
						(+ (client y?) [local46 clientLoop])
						20
					init:
					setCycle: Forward
					setScript: (ballScript new:)
				)
				(= state -1)
				(client view: 175 cycleSpeed: 3 setCycle: EndLoop self)
			)
			(3
				(client view: 178 setCel: 0)
				(= cycles 2)
			)
			(4
				(client setCel: 1)
				(= cycles 2)
			)
			(5
				(client view: 175 cel: 0 setCel: -1 forceUpd:)
				(= state 0)
				(= cycles 5)
			)
		)
	)
)

(instance kobAsleep of KScript
	(properties)
	
	(method (doit)
		(if
			(and
				(< (ego distanceTo: client) 100)
				(or (!= egoWalkMode MOVE_SNEAK) (< [egoStats STEALTH] 20))
			)
			(localproc_003c 7 15 57)
			(ChangeEgoWalk MOVE_WALK FALSE)
			(client setScript: kobWakeUp)
		)
		(super doit:)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(= koboldHP 67)
				((= newView (View new:))
					view: 175
					loop: 5
					cel: 0
					ignoreActors:
					posn: 229 85
					setPri: 6
					init:
				)
				(client
					posn: (newView x?) (- (newView y?) 17)
					setLoop: 6
					cycleSpeed: 1
				)
			)
		)
	)
)

(instance castRev of KScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(if (not (Btst KOBOLD_CASTING_REVERSAL))
					(Bset KOBOLD_CASTING_REVERSAL)
					(localproc_003c 7 15 58)
				)
				(client
					view: 176
					setLoop: 1
					cel: 0
					cycleSpeed: 1
					setCycle: EndLoop
				)
				(= cycles 10)
			)
			(1
				(Bset 281)
				(client setScript: kobAwake)
			)
		)
	)
)

(instance castTele of KScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(client
					view: 176
					setLoop: 0
					cel: 0
					cycleSpeed: 0
					setCycle: EndLoop self
				)
				(if fightingKobold
					(curRoom setScript: (ScriptID 117 1))
				)
			)
			(1
				(= egoKoboldBattleLoop (- 1 egoKoboldBattleLoop))
				(if global289
					(StopEgo)
					(ego illegalBits: 0)
					((ScriptID 117 0) changeState: 1)
				)
				(if egoKoboldBattleLoop
					(client posn: 52 84)
				else
					(client posn: 229 85)
				)
				(client setCycle: BegLoop self)
			)
			(2 (client setScript: kobAwake))
		)
	)
)

(instance egoDies of KScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(HandsOff)
				(client
					view: 513
					setLoop: egoKoboldBattleLoop
					cel: 0
					illegalBits: 0
					cycleSpeed: 1
					setCycle: EndLoop self
				)
			)
			(1
				(cond 
					((Btst KOBOLD_CHEST_EXPLODED)
						(EgoDead
							15
							59
							80
							{Your plan seems to have backfired}
							82
							15
							2
							6
						)
					)
					(local17 (EgoDead 15 60 80 {Blast!} 82 15 2 6))
					(else (EgoDead 15 61 80 {You've been deep-fried} 82 532 0 1))
				)
			)
		)
	)
)

(instance kobHurt of KScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(if (Btst 150)
					(self dispose:)
				else
					(if newView
						(newView dispose:)
						(= newView 0)
						(if egoKoboldBattleLoop
							(client posn: 52 84)
						else
							(client posn: 229 85)
						)
					)
					(client view: 178 setCycle: 0 setMotion: 0)
					(localproc_0138)
					(client setCel: 2)
					(= cycles 5)
				)
			)
			(1
				(client setCel: 3)
				(= cycles 3)
			)
			(2
				(client setCel: -1)
				(if (> koboldHP 0)
					(= theCycles 3)
					(client setScript: kobAwake)
				else
					(client setScript: kobDies)
				)
			)
		)
	)
)

(instance kobDies of KScript
	(properties)
	
	(method (changeState newState &tmp temp0)
		(switch (= state newState)
			(0
				(HandsOff)
				(Bset DEFEATED_KOBOLD)
				(Bclr KOBOLD_AWAKE)
				(ego setScript: 0)
				(curRoom setScript: 0)
				(= global282 (& global282 $bfff))
				(client
					view: 178
					setLoop: 5
					cel: 0
					cycleSpeed: 1
					setCycle: EndLoop self
				)
				(if (not (Btst OBTAINED_KOBOLD_KEY))
					(kobKey
						show:
						illegalBits: 0
						ignoreActors:
						view: 178
						posn: (kobold x?) (kobold y?)
						setLoop: 6
						cel: 0
						setPri: (if egoKoboldBattleLoop 5 else 1)
						cycleSpeed: 1
						setCycle: EndLoop
					)
				)
			)
			(1
				(= monsterInRoom (= gMonsterHealth 0))
				(if (or (== heroType FIGHTER) (== heroType MAGE))
					(AddToScore POINTS_KILLKOBOLD 10)
				)
				(cSound number: 20 loop: -1 play:)
				(if fightingKobold
					(curRoom setScript: (ScriptID 117 1))
				else
					(HandsOn)
					(curRoom setScript: 0)
				)
				(client dispose:)
			)
		)
	)
)

(instance kobEnter of KScript
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(HandsOff)
				(if (not (Btst VISITED_KOBOLD_CAVE)) (localproc_003c 7 15 62))
				(ego setMotion: MoveTo 65 63 self)
			)
			(1
				(ego setMotion: MoveTo 100 77 self)
			)
			(2 (HandsOn) (self dispose:))
		)
	)
)

(instance egoFighting of KScript
	(properties)
	
	(method (dispose)
		(gDirHandler delete: self)
		(ego setScript: 0 illegalBits: global282)
		(super dispose:)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(if (ego has: iSword)
					(= local13 0)
					(= local14 (= local15 1))
					(= local16 2)
				else
					(= local13 3)
					(= local14 (= local15 (= local16 4)))
				)
				(= fightingKobold 1)
				(gDirHandler addToFront: self)
				(self cue:)
			)
			(1 (KoboldFight 1) (= state 0))
		)
	)
	
	(method (handleEvent event &tmp temp0)
		(cond 
			((super handleEvent: event))
			(
				(and
					(== (event type?) evJOYSTICK)
					(not (ego script?))
				)
				(HandsOff)
				(switch (event message?)
					(JOY_UP
						(ego setScript: (ScriptID 111 local13) self 0)
					)
					(JOY_LEFT
						(ego setScript: (ScriptID 111 local14) self 1)
					)
					(JOY_RIGHT
						(ego setScript: (ScriptID 111 local15) self 2)
					)
					(JOY_DOWN
						(ego setScript: (ScriptID 111 local16) self 3)
					)
					(else 
						(HandsOn)
						(User canControl: FALSE)
					)
				)
			)
		)
	)
)
