;;; Sierra Script 1.0 - (do not remove this comment)
(script# 101)
(include system.sh) (include sci2.sh) (include game.sh)
(use Main)
(use Sound)
(use Motion)
(use Actor)
(use System)

(public
	AnimateThrowingDagger 0
)

(local
	local0
	local1
	local2
	local3
	local4
	gEgoObjSignal
	gEgoObjPriority
	gEgoObjIllegalBits
	newAct
	newSound
)
(procedure (AnimateThrowingDagger target &tmp temp0 temp1 newAct_2)
	(if (!= curRoomNum roomDaggersDropped)
		(= roomDaggersDropped curRoomNum)
		(= daggersInRoom 0)
	)
	(return
		(if (not (ego has: iDagger))
			(HighPrint 101 0)
			;You do not have any daggers.
			(DisposeScript 101)
			(return 0)
		else
			(ego use: iDagger 1)
			(Load RES_SOUND (GetSongNumber 31))
			(Load RES_SOUND (GetSongNumber 29))
			(if target
				(FaceObject ego target)
				(= local3 (+ (target x?) (target targDeltaX?)))
				(= local4 (+ (target y?) (target targDeltaY?)))
				(= temp0 (- local3 (+ (ego x?) 15)))
				(= temp1 (- local4 (- (ego y?) 40)))
				(while
					(and
						(< 0 local3)
						(< local3 319)
						(< 0 local4)
						(< local4 189)
					)
					(= local3 (+ local3 temp0))
					(= local4 (+ local4 temp1))
				)
				(if
					(not
						(TrySkill THROW 0 (- 50 (/ (ego distanceTo: target) 5)))
					)
					(if (< local4 0)
						(= local4 (+ local4 (Random 30 100)))
					else
						(= local4 (- local4 (Random 30 100)))
					)
				)
			)
			(if (not target)
				(SkillUsed THROW (/ [egoStats AGIL] 10))
				(= local3 (if (& (ego loop?) $0001) -10 else 330))
				(= local4 (Random 20 80))
			)
			((= newSound (Sound new:))
				number: (GetSongNumber 31)
				priority: 15
				init:
			)
			(= local0 target)
			((= newAct_2 (Actor new:))
				view: 524
				setLoop: 2
				setCel: 0
				illegalBits: 0
				ignoreActors:
				ignoreHorizon:
				z: 20
				posn: (ego x?) (- (ego y?) 20)
				setStep: 12 8
				init:
				hide:
				setScript: knifeScript 0 target
			)
			(return TRUE)
		)
	)
)

(instance knifeScript of Script
	(properties)
	
	(method (doit &tmp temp0)
		(asm
			pushi    1
			lsl      local0
			callk    IsObject,  2
			bnt      code_0250
			pushi    #x
			pushi    0
			lal      local0
			send     4
			push    
			pushi    #targDeltaX
			pushi    0
			lal      local0
			send     4
			add     
			sal      local3
			pushi    #y
			pushi    0
			lal      local0
			send     4
			push    
			pushi    #targDeltaY
			pushi    0
			lal      local0
			send     4
			add     
			sal      local4
code_0250:
			pushi    #x
			pushi    0
			pToa     client
			send     4
			push    
			lal      local3
			sub     
			sal      local1
			pushi    #y
			pushi    0
			pToa     client
			send     4
			push    
			lal      local4
			sub     
			sal      local2
			pTos     state
			ldi      1
			eq?     
			bnt      code_02d8
			pushi    65521
			lal      local1
			lt?     
			bnt      code_028d
			pprev   
			ldi      15
			lt?     
			bnt      code_028d
			pushi    65521
			lal      local2
			lt?     
			bnt      code_028d
			pprev   
			ldi      15
			lt?     
code_028d:
			sat      temp0
			bt       code_02c7
			pushi    #mover
			pushi    0
			pToa     client
			send     4
			not     
			bt       code_02c7
			pushi    0
			pushi    #x
			pushi    0
			pToa     client
			send     4
			lt?     
			bnt      code_02ae
			pprev   
			ldi      319
			lt?     
code_02ae:
			not     
			bt       code_02c7
			pushi    0
			pushi    #y
			pushi    0
			pToa     client
			send     4
			lt?     
			bnt      code_02c3
			pprev   
			ldi      189
			lt?     
code_02c3:
			not     
			bnt      code_02d8
code_02c7:
			pToa     register
			bnt      code_02ce
			lat      temp0
code_02ce:
			sal      gEgoObjSignal
			pushi    #cue
			pushi    0
			self     4
			jmp      code_02de
code_02d8:
			pushi    #doit
			pushi    0
			super    Script,  4
code_02de:
			ret     
		)
	)
	
	(method (dispose)
		(newSound dispose:)
		(HandsOn)
		(if (and gEgoObjSignal (IsObject register))
			(register getHurt: (+ 5 (/ [egoStats STR] 10)))
		)
		(super dispose:)
		(DisposeScript 101)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(= gEgoObjPriority (ego signal?))
				(= gEgoObjIllegalBits (ego priority?))
				(= newAct (ego illegalBits?))
				(HandsOff)
				(ego
					view: 524
					setLoop: (if (& (ego loop?) $0001) 1 else 0)
					cel: 0
					setCycle: CycleTo 9 1 self
				)
				(++ daggersInRoom)
			)
			(1
				(ego setCycle: EndLoop)
				(newSound play:)
				(client
					x: (if (== (ego loop?) 1)
						(- (ego x?) 15)
					else
						(+ (ego x?) 15)
					)
					show:
					setLoop: (+ (ego loop?) 2)
					setMotion: MoveTo local3 local4
				)
			)
			(2
				(client hide:)
				(if gEgoObjSignal
					(-- daggersInRoom)
					(++ daggersInMonster)
					(newSound stop: number: (GetSongNumber 29) play: self)
				else
					(= cycles 1)
				)
			)
			(3
				(StopEgo)
				(ego
					priority: gEgoObjIllegalBits
					illegalBits: newAct
					signal: gEgoObjPriority
				)
				(client dispose:)
			)
		)
	)
)
