;;; Sierra Script 1.0 - (do not remove this comment)
(script# 213)
(include system.sh) (include sci2.sh) (include game.sh)
(use Main)
(use StatusBar)
(use Skilled)
(use Inventory)
(use Actor)

(public
	warrior 0
)

(class Warrior of Skilled
	(properties
		y 0
		x 0
		z 0
		heading 0
		yStep 10
		view 0
		loop 0
		cel 0
		priority 0
		underBits 0
		signal $0000
		nsTop 0
		nsLeft 0
		nsBottom 0
		nsRight 0
		lsTop 0
		lsLeft 0
		lsBottom 0
		lsRight 0
		brTop 0
		brLeft 0
		brBottom 0
		brRight 0
		cycleSpeed 0
		script 0
		cycler 0
		timer 0
		illegalBits $8000
		xLast 0
		yLast 0
		xStep 16
		moveSpeed 0
		blocks 0
		baseSetter 0
		mover 0
		looper 0
		viewer 0
		avoider 0
		strength 0
		intell 0
		agil 0
		vit 0
		luck 0
		weap 0
		parry 0
		dodge 0
		magic 0
		stamina 0
		health 0
		mana 0
		armorValue 0
		armorEnc 0
		shieldValue 0
		weapValue 0
		canFight 0
		action 0
		opponent 0
		fightLeft 0
		heroTitle 0
		egoHP 0
		egoSP 0
		egoMP 0
		weaponView 0
		egosBack 0
		egoShield 0
		egoHand 0
		usingSword 0
		noWeapon 0
		baseX 190
		baseY 190
	)
	
	(method (init)
		(= strength [egoStats STR])
		(= intell [egoStats INT])
		(= agil [egoStats AGIL])
		(= vit [egoStats VIT])
		(= luck [egoStats LUCK])
		(= weap [egoStats WEAPON])
		(= parry [egoStats PARRY])
		(= dodge [egoStats DODGE])
		(= magic [egoStats MAGIC])
		(= stamina [egoStats STAMINA])
		(= health [egoStats HEALTH])
		(= mana [egoStats MANA])
		(super init: &rest)
	)
	
	(method (dispose)
		(Bclr HERO_KILLED_IN_BATTLE)
		(if egoMP (egoMP dispose:) (= egoMP 0))
		(if heroTitle
			(egoSP dispose:)
			(egoHP dispose:)
			(Display 213 0 108 heroTitle)
			;Hero Status
			(= heroTitle (= egoHP (= egoSP 0)))
		)
		(super dispose:)
	)
	
	(method (getHurt param1)
		(ReduceHP param1)
		(super getHurt: param1)
		(self setEgoHP: health)
		(cond 
			((or (Btst HERO_KILLED_IN_BATTLE) (<= health 0))
				(Animate (gCast elements?) 0)
				(EgoDead 213 2
					#title {What a monster!}
					#icon 516 0 9)
					;It was a tough battle, and you lost. Never fear!
					;All you have to do is restore your game, and...\nWhat do you mean, "Restore WHAT game?"
			)
			((not (script script?)) (script setScript: (ScriptID 155 0)))
		)
	)
	
	(method (getTired param1)
		(ReduceSP param1)
		(super getTired: param1)
		(self setEgoSP: stamina)
	)
	
	(method (die)
		(Bset HERO_KILLED_IN_BATTLE)
	)
	
	(method (startCombat param1)
		(self setScript: (ScriptID param1 0))
	)
	
	(method (drawStatus)
		(= heroTitle
			(Display
				213 1
				p_width 80
				p_at 13 13
				p_mode teJustLeft
				p_font 300
				p_color hpFontColour
				p_save
			)
		)
		((= egoHP (StatusBar new:))
			x: 25
			y: 33
			titleCel: 0
			priority: 1
			max: (GetMaxHealth)
			value: health
			init:
		)
		((= egoSP (StatusBar new:))
			x: 25
			y: 47
			titleCel: 1
			priority: 1
			max: (GetMaxStamina)
			value: [egoStats STAMINA]
			init:
		)
		(if [egoStats MAGIC]
			((= egoMP (StatusBar new:))
				x: 25
				y: 61
				titleCel: 2
				priority: 1
				max: (GetMaxMana)
				value: [egoStats MANA]
				init:
			)
		)
	)
	
	(method (drawWeapons &tmp theArmorEnc)
		(= baseX (opponent warriorX?))
		(= baseY (opponent warriorY?))
		(= shieldValue (= egoShield 0))
		(if (ego has: iShield)
			(= shieldValue 10)
			((= egoShield aShield)
				view: 540
				setLoop: 1
				setCel: 0
				setPri: 14
				x: (- baseX 74)
				y: baseY
				ignoreActors: 1
				init:
				stopUpd:
			)
		else
			(= shieldValue 0)
			((= egoHand aHand)
				view: 535
				setLoop: 1
				setCel: 0
				setPri: 14
				x: (- baseX 73)
				y: baseY
				ignoreActors: 1
				init:
				stopUpd:
			)
		)
		(= armorEnc (/ (= theArmorEnc (GetTotalWeight)) 2))
		(if (> theArmorEnc (GetMaxWeight))
			(= armorEnc theArmorEnc)
		)
		(= armorValue 0)
		(cond 
			((ego has: iChainmail) (= armorValue 5))
			((ego has: iLeather) (= armorValue 3))
		)
		(cond 
			((ego has: iSword) (= weaponView 540) (self weapValue: 8))
			((ego has: iDagger) (= weaponView 535) (self weapValue: 5))
			(else (= weaponView 542) (= noWeapon TRUE))
		)
		((= egosBack closeupEgo)
			view: 541
			setLoop: 0
			setCel: 0
			setPri: 15
			x: (- baseX 41)
			y: baseY
			ignoreActors: 1
			init:
			stopUpd:
		)
		(self
			illegalBits: 0
			ignoreActors: 1
			view: weaponView
			setLoop: (if noWeapon 0 else 2)
			cel: 0
			setPri: 11
			posn: baseX baseY
			stopUpd:
		)
	)
	
	(method (setEgoHP theSkills)
		(= [egoStats HEALTH] theSkills)
		(if egoHP (egoHP value: theSkills draw:))
	)
	
	(method (setEgoMP theMana)
		(= mana theMana)
		(if egoMP (egoMP value: theMana draw:))
	)
	
	(method (setEgoSP theSkills)
		(= [egoStats STAMINA] theSkills)
		(if egoSP (egoSP value: theSkills draw:))
	)
)

(instance warrior of Warrior
	(properties)
)

(instance aShield of View
	(properties)
)

(instance aHand of Prop
	(properties)
)

(instance closeupEgo of View
	(properties)
)
