;;; Sierra Script 1.0 - (do not remove this comment)
(script# 171)
(include system.sh) (include sci2.sh) (include game.sh)
(use Main)
(use LoadMany)
(use Sound)
(use Motion)
(use Game)
(use Inventory)
(use Actor)
(use System)

(public
	rmBear 0
)

(local
	local0
	[local1 20]
	[local21 20]
	[local41 20] = [2 4 3 3 2 4 2 2 3 4 1 1 3 4 4 4 4 1 3 1]
	[local61 40] = [156 6 119 25 99 50 79 74 100 102 119 94 107 145 140 173 140 153 170 162 193 175 189 133 211 105 213 59 198 37 181 19 144 35 170 35 140 85 176 125]
	[local101 40]
	[local141 5] = [144 249 283 88 165]
	[local146 5] = [184 221 219 201 168]
	local151
)
(procedure (localproc_000c)
	(= local0 0)
	(while (< local0 20)
		(= [local1 local0] (Clone star))
		([local1 ([local21 (= [local21 local0] (Clone starScriptOn))]
			register: [local41 local0]
		)]
			cel: 0
			init:
			setPri: 15
			posn: [local61 (* local0 2)] [local61 (+ (* local0 2) 1)]
			setScript: [local21 local0]
		)
		(++ local0)
	)
)

(procedure (localproc_0070)
	(= local0 0)
	(while (< local0 20)
		(= [local1 local0] (Clone star))
		([local1 ([local21 (= [local21 local0] (Clone starScriptOff))]
			register: [local41 local0]
		)]
			cel: (- [local41 local0] 1)
			init:
			setPri: 15
			posn: [local61 (* local0 2)] [local61 (+ (* local0 2) 1)]
			setScript: [local21 local0]
		)
		(++ local0)
	)
)

(procedure (localproc_00db)
	(= local0 19)
	(while (>= local0 0)
		([local21 local0] dispose:)
		([local1 local0] dispose:)
		(-- local0)
	)
)

(procedure (BarnardDies)
	(curRoom drawPic: 420)
	(bearRightPaw init: setPri: 6 stopUpd:)
	(bearLeftPaw init: setPri: 5 stopUpd:)
	(bearHead init: setPri: 4 setLoop: 0 cel: 0 stopUpd:)
)

(procedure (BarnardFree)
	(curRoom drawPic: 420)
	(bearRightPaw init: setPri: 6 stopUpd:)
	(bearLeftPaw init: setPri: 5 stopUpd:)
	(bearHead init: setPri: 4 setLoop: 3 cel: 0 stopUpd:)
)

(procedure (localproc_0190)
	(localproc_00db)
	(bearHead dispose:)
	(bearRightPaw dispose:)
	(bearLeftPaw dispose:)
	(curRoom drawPic: 400 8)
)

(procedure (localproc_01bb)
	(baronet init: setPri: 4 stopUpd:)
	(baronHead init: setPri: 5 setLoop: 0 cel: 0 stopUpd:)
	(baronRightArm init: setPri: 7 setLoop: 6 cel: 0 stopUpd:)
	(baronLeftArm init: setPri: 6 setLoop: 5 cel: 0 stopUpd:)
)

(procedure (localproc_021d)
	(baronet init: setPri: 4 stopUpd:)
	(baronHead init: setPri: 5 setLoop: 1 cel: 0 stopUpd:)
	(baronRightArm init: setPri: 7 setLoop: 6 cel: 0 stopUpd:)
	(baronLeftArm init: setPri: 6 setLoop: 5 cel: 0 stopUpd:)
)

(procedure (localproc_027f)
	(baronet dispose:)
	(baronHead dispose:)
	(baronRightArm dispose:)
	(baronLeftArm dispose:)
	(curRoom drawPic: 14 3)
	(StopEgo)
	(ego init: posn: 141 140)
	(drip init: setScript: dripScript)
	(= local151 (Random 0 4))
	(Bset BEAR_GONE)
	(if (Btst DEFEATED_BEAR)
		(baronetSmall init: x: 239 y: 135 loop: 0)
	else
		(baronetSmall init: x: 239 y: 135 loop: 1)
	)
)

(instance bearChange of Sound
	(properties
		number 70
		priority 3
	)
)

(instance rmBear of Room
	(properties
		picture 420
	)
	
	(method (init)
		(Load RES_PIC 400)
		(Load RES_PIC 14)
		(LoadMany RES_VIEW 423 422 421 424)
		(StatusLine enable:)
		(super init:)
		(HandsOff)
		(= monsterInRoom 0)
		(if (Btst DEFEATED_BEAR)
			(BarnardDies)
			(self setScript: bearDying)
		else
			(BarnardFree)
			(self setScript: bearFreed)
		)
	)
	
	(method (doit)
		(cond 
			((== (ego edgeHit?) 2) (curRoom newRoom: 15))
			((== (ego edgeHit?) 3) (curRoom newRoom: 13))
		)
		(super doit:)
	)
	
	(method (dispose)
		(= gMonsterHealth (= monsterInRoom FALSE))
		(super dispose:)
	)
	
	(method (handleEvent event &tmp spell)
		(switch (event type?)
			(evSAID
				(cond 
					((Said 'look>')
						(cond 
							((Said '/stalactite')
								(HighPrint 171 0)
								;They're like stalagmites, but they go the other way.
								)
							((Said '/stalagmite')
								(HighPrint 171 1)
								;They're like stalactites, but they go the other way.
								)
							((Said '[<at,around][/!*,cave,room]')
								(HighPrint 171 2)
								;The cavern contains some impressive formations and is rather beautiful, as caves go.
								)
							((Said '/wall,fungus,north,west,formation')
								(HighPrint 171 3)
								;The stalactites, stalagmites, and cave walls glow from a phosphorescent fungus growing there.
								)
							((or (Said '<up') (Said '/ceiling'))
								(HighPrint 171 4)
								;The stalactites grow slowly.
								(HighPrint 171 5)
								;...or are they stalagmites?
								)
							((or (Said '<down') (Said '/floor'))
								(HighPrint 171 6)
								;The stalagmites grow slowly.
								(HighPrint 171 7)
								;...or are they stalactites?
								)
							((Said '/south,entrance,open')
								(HighPrint 171 8)
								;The light from outside illuminates the cave opening.
								)
							((Said '/east')
								(HighPrint 171 9)
								;Beyond the bear, the cave seems to continue.
								)
							((Said '/bear,animal,creature,monster')
								(if (Btst DEFEATED_BEAR)
									(HighPrint 171 10)
									;The bear is gone.  All that is left is the body of a dead man.
								else
									(HighPrint 171 11)
									;The bear is gone.
								)
							)
							((Said '/man,barnard')
								(if (Btst DEFEATED_BEAR)
									(HighPrint (Format @local101 171 12 userName)
										;He's dead, %s.
										)
								else
									(HighPrint 171 13)
									;The man is gone.
									
								)
							)
						)
					)
					((Said 'get>')
						(cond 
							((Said '/fungus')
								(HighPrint 171 14)
								;The fungus is slimy and stuck tight to the cave walls.
								)
							((Said '/bear,stalactite,stalagmite')
								(HighPrint 171 15)
								;You're kidding, right?
								)
						)
					)
					((Said 'cast>')
						(switch (= spell (SaidCast event))
							(DETMAGIC
								(if (CastSpell spell)
									(HighPrint 171 16)
									;There is no magic in the cavern.
									)
							)
							(else  (event claimed: FALSE))
						)
					)
				)
			)
		)
		(super handleEvent: event)
	)
)

(instance bearDying of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(bearHead cel: 1)
				(bearChange init: play:)
				(= cycles 3)
			)
			(1
				(SetCursor theCursor 0)
				(bearHead cycleSpeed: 1 setCycle: EndLoop)
				(= cycles 5)
			)
			(2
				(localproc_000c)
				(= cycles 16)
			)
			(3
				(localproc_0190)
				(localproc_0070)
				(self cue:)
			)
			(4
				(localproc_01bb)
				(= cycles 4)
			)
			(5
				(baronLeftArm loop: 7 cel: 1 stopUpd:)
				(baronRightArm loop: 7 cel: 0 stopUpd:)
				(baronHead cycleSpeed: 1 setCycle: EndLoop)
				(= cycles 13)
			)
			(6
				(localproc_00db)
				(localproc_027f)
				(= cycles 11)
			)
			(7
				(baronetSmall cycleSpeed: 3 setCycle: EndLoop self)
			)
			(8
				(if (Btst READ_BARNARD_BULLETIN)
					(HighPrint 171 17)
					;The body lying there looks a lot like the picture of the Baronet von Spielburg on the poster at the guild hall.
					;You have a funny feeling that you may have made a slight tactical error.
				else
					(HighPrint 171 18)
					;You have a funny feeling that you may have made a slight tactical error.
				)
				(baronetSmall
					cel: 0
					loop: 4
					cycleSpeed: 1
					setCycle: EndLoop self
				)
			)
			(9
				(Bclr DEFEATED_BEAR)
				(baronetSmall dispose:)
				(SetCursor theCursor 1)
				(HandsOn)
			)
		)
	)
)

(instance bearFreed of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(bearChange init: play:)
				(= cycles 3)
			)
			(1
				(SetCursor theCursor 0)
				(localproc_000c)
				(= cycles 20)
			)
			(2
				(localproc_0190)
				(localproc_0070)
				(self cue:)
			)
			(3
				(localproc_021d)
				(= cycles 4)
			)
			(4
				(baronHead loop: 1 cel: 0 setCycle: EndLoop self)
			)
			(5
				(baronHead stopUpd:)
				(= cycles 4)
			)
			(6
				(baronLeftArm loop: 5 cel: 0 setCycle: Forward)
				(= cycles 5)
			)
			(7
				(baronLeftArm stopUpd:)
				(baronHead setCycle: BegLoop self startUpd:)
			)
			(8
				(baronHead loop: 2 cel: 0 setCycle: EndLoop self)
			)
			(9
				(baronHead stopUpd:)
				(= cycles 4)
			)
			(10
				(baronRightArm loop: 6 cel: 0 setCycle: Forward)
				(= cycles 5)
			)
			(11
				(baronRightArm stopUpd:)
				(= cycles 4)
			)
			(12
				(baronHead setCycle: BegLoop)
				(localproc_00db)
				(= cycles 5)
			)
			(13
				(baronHead loop: 3 cel: 0 setCycle: EndLoop self)
				(= cycles 5)
			)
			(14
				(localproc_027f)
				(= cycles 11)
			)
			(15
				(baronetSmall setCycle: EndLoop self)
			)
			(16
				(HighPrint 171 19)
				;"You have the honor of meeting the Baronet Barnard von Spielburg.  We are pleased that you broke our enchantment.
				;Perhaps our father the Baron will reward you should you ever visit our castle."
				(= cycles 3)
			)
			(17
				(baronetSmall
					loop: 3
					cel: 0
					cycleSpeed: 1
					setCycle: EndLoop self
				)
			)
			(18
				(baronetSmall dispose:)
				(HighPrint 171 20)
				;The arrogance of the Baronet astonishes you.  Perchance the kobold Magic User had a reason for changing him into a bear.
				(SetCursor theCursor 1)
				(HandsOn)
				(self dispose:)
			)
		)
	)
)

(instance starScriptOn of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0 (= cycles (* register 3)))
			(1 (client setCycle: EndLoop self))
			(2
				(client loop: 1 cel: 0 setCycle: Forward)
			)
		)
	)
)

(instance starScriptOff of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(client loop: 1 cel: 0 setCycle: Forward)
				(= cycles (* register 3))
			)
			(1
				(client loop: 0 cel: 5 setCycle: BegLoop)
			)
		)
	)
)

(instance dripScript of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(drip
					posn: [local141 local151] [local146 local151]
					setCycle: EndLoop
				)
				(= cycles (Random 20 40))
			)
			(1
				(= local151 (Random 0 4))
				(self changeState: 0)
			)
		)
	)
)

(instance bearHead of Prop
	(properties
		y 68
		x 156
		view 422
		priority 4
	)
)

(instance bearRightPaw of View
	(properties
		y 42
		x 115
		view 422
		loop 1
		priority 6
	)
)

(instance bearLeftPaw of View
	(properties
		y 39
		x 199
		view 422
		loop 2
		priority 5
	)
)

(instance baronet of View
	(properties
		y 199
		x 158
		view 423
		loop 4
		priority 4
	)
)

(instance baronHead of Prop
	(properties
		y 72
		x 156
		view 423
		priority 5
	)
)

(instance baronHeadSmall of Prop
	(properties
		y 140
		x 130
		z 25
		view 421
		loop 2
		priority 5
	)
)

(instance baronetSmall of Actor
	(properties
		y 140
		x 130
		view 421
		priority 12
	)
)

(instance baronRightArm of Prop
	(properties
		y 60
		x 135
		view 423
		loop 6
		priority 7
	)
)

(instance baronLeftArm of Prop
	(properties
		y 61
		x 177
		view 423
		loop 5
		priority 6
	)
)

(instance star of Prop
	(properties
		y 95
		x 107
		view 424
		cel 1
		priority 12
	)
)

(instance drip of Prop
	(properties
		y 204
		x 79
		view 15
	)
)
